// Questionario: http://preview.tinyurl.com/pb9clc2
// Corso: Ingegneria degli Algoritmi, Sapienza U Roma
// Docente: Camil Demetrescu
// Creato: 3 maggio 2014
// Test: gcc domanda13.c -o domanda13; ./domanda13

#include <stdio.h>

int main() {
    
    // test piattaforma 64 bit: deve stampare 4 8
    printf("%u %u\n", (unsigned)sizeof(int), 
                      (unsigned)sizeof(void*));

    int v[10][20];
    
    // errato
    //int** u1 = v;
    
    // corretto
    int (*u2)[20] = v;
    
    // equivalenti
    printf("%p %p\n", &( v[2][3] ), &( *(*(v+2)+3) ));

    // non equivalenti
    printf("%p %p\n", &( v[2][3] ), &( *(*(v+3)+2) ));

    // non equivalenti
    //(*(v+2)+3) = v[2][3];

    // non equivalenti
    //(*(v+3)+2) = v[2][3];

    // stampa 800 se sizeof(int)==4
    printf("%u\n", (unsigned)sizeof(v));

    // stampa 80 se sizeof(int)==4
    printf("%u\n", (unsigned)sizeof(v[5]));

    return 0;
}
