// Questionario: http://preview.tinyurl.com/pb9clc2
// Corso: Ingegneria degli Algoritmi, Sapienza U Roma
// Docente: Camil Demetrescu
// Creato: 3 maggio 2014
// Test: gcc domanda12.c -o domanda12; ./domanda12

#include <stdio.h>

int main() {
    
    int v[10] = { 11, 22, 33, 44, 55, 66, 77, 88, 99, 110 };

    // corretto
    int* u1 = v;     

    // corretto
    int* u2 = v+5;   

    // errato
    //int u[10] = v; 

    // non equivalenti (denotano oggetti diversi)
    printf("%p %p\n", &( *(v+5*sizeof(int)) ), &( v[5] ));

    // equivalenti
    printf("%d %d\n", *(v+5), v[5]);

    // equivalenti
    printf("%d %d\n", *(v+5), 5[v]);

    // equivalenti
    printf("%p %p\n", v+5, &v[5]);

    // non equivalenti
    printf("%p %p\n", v+5*sizeof(int), &v[5]);
    
    return 0;
}
